precision mediump float;

uniform sampler2D u_tex;
uniform vec2 u_size;
uniform mat4 u_colMat;
uniform vec4 u_colAdd;
uniform float u_alpha;

varying vec2 coord;

vec4 k0, k1, k2, k3, k4, k5, k6, k7, k8, k9, k10, k11, k12;
vec4 k13, k14, k15, k16, k17, k18, k19, k20, k21, k22, k23, k24;

void main()
{
    float strength = 10. * u_alpha;

    vec4 col = vec4(0.);

    vec3 offset = vec3(1. / u_size, 0.);

    k0 = texture2D(u_tex, coord + vec2(-2, -2) * offset.xy);
    k1 = texture2D(u_tex, coord + vec2(-2, -1) * offset.xy);
    k2 = texture2D(u_tex, coord + vec2(-2, 0) * offset.xy);
    k3 = texture2D(u_tex, coord + vec2(-2, 1) * offset.xy);
    k4 = texture2D(u_tex, coord + vec2(-2, 2) * offset.xy);

    k5 = texture2D(u_tex, coord + vec2(-1, -2) * offset.xy);
    k6 = texture2D(u_tex, coord + vec2(-1, -1) * offset.xy);
    k7 = texture2D(u_tex, coord + vec2(-1, 0) * offset.xy);
    k8 = texture2D(u_tex, coord + vec2(-1, 1) * offset.xy);
    k9 = texture2D(u_tex, coord + vec2(-1, 2) * offset.xy);

    k10 = texture2D(u_tex, coord + vec2(0, -2) * offset.xy);
    k11 = texture2D(u_tex, coord + vec2(0, -1) * offset.xy);
    k12 = texture2D(u_tex, coord + vec2(0, 0) * offset.xy);
    k13 = texture2D(u_tex, coord + vec2(0, 1) * offset.xy);
    k14 = texture2D(u_tex, coord + vec2(0, 2) * offset.xy);

    k15 = texture2D(u_tex, coord + vec2(1, -2) * offset.xy);
    k16 = texture2D(u_tex, coord + vec2(1, -1) * offset.xy);
    k17 = texture2D(u_tex, coord + vec2(1, 0) * offset.xy);
    k18 = texture2D(u_tex, coord + vec2(1, 1) * offset.xy);
    k19 = texture2D(u_tex, coord + vec2(1, 2) * offset.xy);

    k20 = texture2D(u_tex, coord + vec2(2, -2) * offset.xy);
    k21 = texture2D(u_tex, coord + vec2(2, -1) * offset.xy);
    k22 = texture2D(u_tex, coord + vec2(2, 0) * offset.xy);
    k23 = texture2D(u_tex, coord + vec2(2, 1) * offset.xy);
    k24 = texture2D(u_tex, coord + vec2(2, 2) * offset.xy);

    col += 1. * k0 +  4. * k1 +  6. * k2 +  4. * k3 + 1. * k4;
    col += 4. * k5 + 16. * k6 + 24. * k7 + 16. * k8 + 4. * k9;
    col += 6. * k10 + 24. * k11 -476. * k12 + 24. * k13 + 6. * k14;
    col += 4. * k15 + 16. * k16 + 24. * k17 + 16. * k18 + 4. * k19;
    col += 1. * k20 +  4. * k21 +  6. * k22 +  4. * k23 + 1. * k24;

    col *= -1./256.;

    col = mix(k12/*texture2D(u_tex, coord)*/, col, strength);

    gl_FragColor = u_colMat * col + u_colAdd;
}