precision mediump float;

uniform sampler2D u_tex;
uniform mat4 u_colMat;
uniform vec4 u_colAdd;
uniform vec4 u_rgbScale; // (rPower, gPower, bPower, alpha)

varying vec2 coord;


void main()
{
    vec2 c = sign(coord) * vec2(.5);

    vec2 rr = u_rgbScale.r * (coord - c) + c;
    vec2 gg = u_rgbScale.g * (coord - c) + c;
    vec2 bb = u_rgbScale.b * (coord - c) + c;

    // Performe color abberation after applying color matrix
    float r = (u_colMat * texture2D(u_tex, rr) + u_colAdd).r;
    float g = (u_colMat * texture2D(u_tex, gg) + u_colAdd).g;
    float b = (u_colMat * texture2D(u_tex, bb) + u_colAdd).b;

    gl_FragColor = vec4(r, g, b, 1.);
}
