precision mediump float;

uniform sampler2D u_tex;
uniform vec2 u_size;
uniform mat4 u_colMat;
uniform vec4 u_colAdd;
uniform float u_alpha;

varying vec2 coord;

void main()
{
    float strength = 10. * u_alpha;

    vec4 col = (1. + 4./9. * strength) * texture2D(u_tex, coord);

    vec3 offset = vec3(1. / u_size, 0.);

    col -= 1./9. * strength * texture2D(u_tex, coord + offset.xz);
    col -= 1./9. * strength * texture2D(u_tex, coord - offset.xz);
    col -= 1./9. * strength * texture2D(u_tex, coord + offset.zy);
    col -= 1./9. * strength * texture2D(u_tex, coord - offset.zy);

    gl_FragColor = u_colMat * col + u_colAdd;
}